--Sonic The Dribblehog! by Aiire/Sir Thoksalot
--This ability started out as just one of my experiments...
--also i'll address dripplehog as dribs :)

--local variables

local MAXDRIBBLES = 5  --Maximum numbers of dribbles
local DROPHEIGHT = -2*FRACUNIT --The speed of the drop

local WATERFACTOR = FRACUNIT*6/9 --Height buff while super, also haha funi numbr

local FINALFACTOR = FRACUNIT*4/9--Height nerf for the final bounce

--We can't be doing the following things:
local function canDribble(player)
	return (player.playerstate == PST_LIVE)
		and not (player.powers[pw_carry]) --Buzz off, Tails!
		and not P_CheckDeathPitCollide(player.mo) --You have to be alive first, go figure!
		and not P_PlayerInPain(player) --Ouch!
		and not P_IsObjectInGoop(player.mo) --Uh no?
		and not (player.exiting > 0)
		and not (player.playerstate != PST_LIVE)
		and not (player.dribbleint == MAXDRIBBLES)
		and not (player.mo.state == S_PLAY_DEAD)
end

--Last momz
local function lastMomZ(player)
	local momz = FixedMul(player.prevmomz, P_GetMobjGravity(player.mo))
	
	return momz + 14*FRACUNIT
end
	
--Bounce height
local function bounceHeight(player)
	local bnceheight = FixedMul(lastMomZ(player), player.mo.scale) - (player.dribbleint*FRACUNIT) --+ P_GetMobjGravity(player.mo)

	--Water decreases the bounce height by 40%
	if (player.mo.eflags & MFE_UNDERWATER) then
		bnceheight = FixedMul($, WATERFACTOR)
	end
	--Limit the speed, please...
	if (player.finalbounce == true)
		bnceheight = FixedMul($, FINALFACTOR)
	end
	
	return max(bnceheight, 10*FRACUNIT)
end

--Drop height
local function dropHeight(player)
	local drpheight = DROPHEIGHT + P_GetMobjGravity(player.mo)
	--Water decreases the drop height a lttile
	if (player.mo.eflags & MFE_UNDERWATER) then
		drpheight = $1 + 1*FRACUNIT
	end
	
	return drpheight
end

--The screen should only shake for those who can see the player creating them
local function quake(player, intensity, time)
	if player == displayplayer
		P_StartQuake(intensity, time)
	end
end

--bounce sound
local function startDribbleSound(player)
	S_StartSound(mo, sfx_s3kaa)
	S_StopSoundByID(mo, sfx_s3ka0)
end
	
--Spawn bounce dust
local function spawnDust(mobj)
	for i = 1, 16
		local dust = P_SpawnMobjFromMobj(mobj, 0, 0, 0, MT_SPINDUST)
		P_InstaThrust(dust, i*((ANG10+ANG1)*2), P_RandomRange(-10, 10)*mobj.scale)
		P_SetScale(dust, mobj.scale*2)
		dust.destscale = mobj.scale/9
		dust.frame = $ | TR_TRANS40
		dust.fuse = TICRATE*2
	end
end
		
addHook("ThinkFrame", do
	for player in players.iterate()
		if (player.mo and player.mo.valid)
			local mo = player.mo
			--IDGAF if youre not dribs
			if not (mo.skin == "dribblehog") return end
			--speen
			player.charability2 = CA2_SPINDASH
			--Variables
			if (player.dribbled == nil) or not canDribble(player) --or not (player.pflags & PF_THOKKED
				player.dribbled = false
				player.dribbleint = 0 --Checks how many time we have dribbled
				player.finalbounce = false
			end
			--momz from the last tic
			if (player.prevmomz == nil)
			and not ((mo.eflags & MFE_JUSTHITFLOOR) or P_IsObjectOnGround(mo))
				player.prevmomz = 1*FRACUNIT
			end
			
			--OH NO!
			if player.powers[pw_super]
				CONS_Printf(player, "OH NO! Dribblehog couldn't handle the power of the chaos emeralds!")
				S_StartSound(mo, sfx_s3k66, player)
				P_KillMobj(mo, mo, mo)
			end
			
			--Now we actually code the ability
			if (player.dribbled) and canDribble(player)
				P_SetObjectMomZ(mo, dropHeight(player), true)
				if (mo.state != S_PLAY_ROLL) and (mo.state != S_PLAY_SPRING)
					mo.state = S_PLAY_ROLL
				end
				local ghost = P_SpawnGhostMobj(mo)
				ghost.fuse = 4
				if (player.tracer)
					player.tracer.fuse = 4
				end
				
				ghost.rollangle = mo.rollangle
				
				for i = 1, 9
					ghost.scale = FRACUNIT - (i * FRACUNIT/150)
					ghost.destscale = 0
				end
				
				player.pflags = $1 | PF_JUMPSTASIS --Knuckles jump height
				
				--If we've hit the floor
				if (mo.eflags & MFE_JUSTHITFLOOR)
					if (player.speed >= 5*mo.scale) and (player.cmd.buttons & BT_USE)
						--speen
						player.pflags = $1 | PF_SPINNING
						mo.state = S_PLAY_ROLL
						S_StartSound(mo, sfx_spin)
						player.dribbled = false
					elseif (player.dribbleint < MAXDRIBBLES) 
						--boing
						startDribbleSound(player)
						--Holding jump lets you bounce higher but doesn't let you bounce afterward
						if (player.cmd.buttons & BT_JUMP)
							--Slight speed reduction
							P_InstaThrust(mo, mo.angle, min(FixedDiv(player.speed, 2*FRACUNIT), player.speed + FRACUNIT))
							player.dribbleint = MAXDRIBBLES
							player.finalbounce = true
							player.dribbled = false
							player.prevmomz = $1 * 2
							player.pflags = $1 | PF_STARTJUMP
							mo.state = S_PLAY_SPRING
						end
						P_SetObjectMomZ(mo, bounceHeight(player))
						--Slight speed gain
						P_Thrust(mo, mo.angle, 8*FRACUNIT)
						player.pflags = $1 | PF_THOKKED
						player.dribbleint = $1 + 1
						--player.prevmomz = $1 * 2
						spawnDust(mo)
						--Your very last bounce has height nerfed so you can't reach for the stars
						if (player.dribbleint == (MAXDRIBBLES - 1))
							player.finalbounce = true
						end
						--spawnDust(mo)
					end
				elseif player.powers[pw_justsprung]
					S_StartSound(mo, sfx_sprong)
					mo.momz = $ * 125/100
					player.dribbled = false
				end
				player.prevmomz = mo.momz
			end
		end
	end
end)

--Damage
addHook("PlayerCanDamage", function(player, mobj)
	if (player.mo and player.mo.valid)
		local mo = player.mo
		--IDGAF if youre not dribs
		if not (mo.skin == "dribblehog") return end
		
		if (player.dribbled or player.finalbounce)
		and mo.state == S_PLAY_ROLL
			return true
		end
	end
end)

--Now dribs can actually dribble
addHook("AbilitySpecial", function(player)
	if (player.mo and player.mo.valid)
		local mo = player.mo
		--IDGAF if youre not dribs
		if not (mo.skin == "dribblehog") return end
		if (player.pflags & PF_THOKKED) return end
		--boing
		S_StartSound(mo, sfx_zoom)
		S_StartSound(mo, sfx_s3ka0)
		P_SetObjectMomZ(player.mo, -2*FRACUNIT, true)
		mo.state = S_PLAY_ROLL
		player.dribbled = true
		player.dribbleint = 0
		player.finalbounce = false
		player.pflags = $1 | PF_THOKKED | PF_JUMPED | PF_SPINNING
		--player.charflags = $1 & !(SF_NOJUMPSPIN) | SF_STOMPDAMAGE
	end
end)